set echo on
set termout on
set trimspool on

spool execute.log

-- turn off cursor caching so it doesn't muddy the water

alter session set session_cached_cursors=0;

set serveroutput on

CREATE OR REPLACE PROCEDURE testparse(num_executions number) is
     dummy_var        VARCHAR2(1); 
     test_cursor      INTEGER; 
     rows_fetched     NUMBER;
     ignore           INTEGER;
  BEGIN 
 
  -- Prepare a cursor to select from the source table: 
     test_cursor := dbms_sql.open_cursor; 
     DBMS_SQL.PARSE(test_cursor, 
          'SELECT dummy from dual', 
          DBMS_SQL.NATIVE);
     DBMS_SQL.DEFINE_COLUMN(test_cursor, 1, dummy_var,1);

     FOR i IN 1..num_executions LOOP
               
  -- execute        
       ignore := DBMS_SQL.EXECUTE(test_cursor); 
       rows_fetched := DBMS_SQL.FETCH_ROWS(test_cursor);
       DBMS_SQL.COLUMN_VALUE(test_cursor, 1, dummy_var); 
     
     END LOOP;

  
  -- close cursor

     DBMS_SQL.CLOSE_CURSOR(test_cursor); 
  END; 
/ 
show errors

select sn.name,ms.value
from V$MYSTAT ms,V$STATNAME sn
where
ms.STATISTIC#=sn.STATISTIC# and
(name like  '%parse%' or name = 'execute count');

execute testparse(1000);

select sn.name,ms.value
from V$MYSTAT ms,V$STATNAME sn
where
ms.STATISTIC#=sn.STATISTIC# and
(name like  '%parse%' or name = 'execute count');


spool off
