set echo on
set termout on
set trimspool on

spool hard.log

-- turn on cursor caching to show that it doesn't
-- eliminate hard parses of unique sql statements

alter session set session_cached_cursors=50;

set serveroutput on

CREATE OR REPLACE PROCEDURE testparse3(num_executions number) is
     dummy_var        VARCHAR2(80);
     query            varchar2(80);
  BEGIN 
 
     FOR i IN 1..num_executions LOOP
       query := 'SELECT dummy||''a'||to_char(i)||''' from dual';
  -- add a unique table alias to force hard parse with each
  -- loop
       execute immediate query into dummy_var;
     
     END LOOP;
 
  END; 
/ 
show errors

select sn.name,ms.value
from V$MYSTAT ms,V$STATNAME sn
where
ms.STATISTIC#=sn.STATISTIC# and
(name like  '%parse%' or name = 'execute count');

execute testparse3(1000);

select sn.name,ms.value
from V$MYSTAT ms,V$STATNAME sn
where
ms.STATISTIC#=sn.STATISTIC# and
(name like  '%parse%' or name = 'execute count');


spool off
